#!/usr/bin/ruby
# coding: utf-8
require "cgi"
require 'yaml'

file_yaml   = "paramexp-cgi.yml"
file_cgitop = "paramexp-cgi_cgitop.txt"
file_cgibot = "paramexp-cgi_cgibot.txt"

def put_message( line )
  put_header
  print line, "\n"
  print "<br>"
  put_footer
end
def put_header
  print <<~EOD
  Content-type: text/html; charset=utf-8

  <html lang="ja">
  <head>
    <meta charset="utf-8">
    <!--
    <meta http-equiv="cache-control" content="private">
    -->
    <title>Parameter experiments</title>
  </head>
  <body>
  EOD
end
def put_footer
  print <<~EOD
    </body>
    </html>
  EOD
end

yml_input = YAML.load_file( file_yaml )

flag_debug     = yml_input["flag_debug"]
flag_show_info = yml_input["flag_show_info"]
flag_dirlink   = yml_input["flag_dirlink"]


pardir  = yml_input["pardir"]


params_name          = yml_input["parameters"].keys

#params_name          = ["RotPeriod", "Obl", "Radius"]
#param_rotperiod_val  = [1, 3, 10, 30, 90]
#param_rotperiod_unit = "Earth days"
#param_obl_val        = [0.0, 23.4, 60.0, 90.0]
#param_obl_unit       = "degrees"
#param_radius_val     = [6371, 4247, 3186]
#param_radius_unit    = "km"


in_hash = CGI.new


fixed_params_val = Array.new( params_name.size )
for i in 0..(params_name.size-1)
  fixed_params_val[i] = in_hash[ params_name[i] ]
end



file_fig         = in_hash[ "variable" ]
param_axisx_name = in_hash[ "param_axisx" ]
param_axisy_name = in_hash[ "param_axisy" ]
fig_width        = in_hash[ "fig_width" ]

if param_axisx_name == param_axisy_name then
  put_header
  print "Error: axisx has to be different from axisy."
  put_footer
  print "<br>"
  exit
end

param_axisx_long_name = yml_input["parameters"][param_axisx_name]["long_name"]
param_axisx_unit      = yml_input["parameters"][param_axisx_name]["unit"]
param_axisx_vals      = yml_input["parameters"][param_axisx_name]["values"]
param_axisx_format    = yml_input["parameters"][param_axisx_name]["label_format"]
#
param_axisy_long_name = yml_input["parameters"][param_axisy_name]["long_name"]
param_axisy_unit      = yml_input["parameters"][param_axisy_name]["unit"]
param_axisy_vals      = yml_input["parameters"][param_axisy_name]["values"]
param_axisy_format    = yml_input["parameters"][param_axisy_name]["label_format"]


#put_header
#for i in 0..(params_name.size-1)
#  print params_name[i], ":", fixed_params_val[i], "\n"
#  print "<br>"
#end
#print param_axisx_name, ":", param_axisx_vals, "\n"
#print "<br>"
#print param_axisy_name, ":", param_axisy_vals, "\n"
#print "<br>"
#put_footer
#exit


# file path
fixed_param_strings = Array.new( params_name.size )
for i in 0..(params_name.size-1)
  name         = params_name[i]
  label_format = yml_input["parameters"][name]["label_format"]
  label        = sprintf( label_format, fixed_params_val[i] )
  fixed_param_strings[i] = name + label
end


if false then
nx = param_axisx_vals.size
ny = param_axisy_vals.size
fig_paths = Array.new( ny ).map{ Array.new( nx ) }
param_strings = Array.new( params_name.size )
param_strings = fixed_param_strings
for j in 0..(param_axisy_vals.size-1)
  label = sprintf( param_axisy_format, param_axisy_vals[j] )
  param_axisy_string = param_axisy_name + label
  for k in 0..(params_name.size-1)
    if params_name[k] == param_axisy_name then
      param_strings[k] = param_axisy_string
    end
  end

  for i in 0..(param_axisx_vals.size-1)
    label = sprintf( param_axisx_format, param_axisx_vals[i] )
    param_axisx_string = param_axisx_name + label
    for k in 0..(params_name.size-1)
      if params_name[k] == param_axisx_name then
        param_strings[k] = param_axisx_string
      end
    end

    string = ""
    for k in 0..(params_name.size-1)
      string += "/" + param_strings[k]
    end

    dir = pardir + string
    fig_path = dir + "/" + file_fig
    fig_paths[j][i] = fig_path
  end
end

end

#########################
nvars = yml_input["file_figs"].size
vars  = yml_input["file_figs"].keys
if param_axisx_name == "VARIABLES" then
  # パラメータ軸が "VARIABLES" のとき, 軸の長さは変数 (ファイル) の数となる
  NParamAxisX = nvars
else
  NParamAxisX = param_axisx_vals.size
end
if param_axisy_name == "VARIABLES" then
  # パラメータ軸が "VARIABLES" のとき, 軸の長さは変数 (ファイル) の数となる
  NParamAxisY = nvars
else
  NParamAxisY = param_axisy_vals.size
end
fig_paths = Array.new( NParamAxisY ).map{ Array.new( NParamAxisX ) }

dir = pardir
for k in 0..(params_name.size-1)
  if params_name[k] != "VARIABLES" then
    # パラメータ軸, "VARIABLES", に対応する図のディレクトリは存在しない
    dir += "/" + fixed_param_strings[k]
  end
end

dir_org = dir
for j in 0..(NParamAxisY-1)
  label = sprintf( param_axisy_format, param_axisy_vals[j] )
  param_axisy_string = param_axisy_name + label

  for i in 0..(NParamAxisX-1)
    label = sprintf( param_axisx_format, param_axisx_vals[i] )
    param_axisx_string = param_axisx_name + label

    dir = dir_org
    if param_axisy_name != "VARIABLES" then
      # パラメータ軸, "VARIABLES", に対応する図のディレクトリは存在しない
      for k in 0..(params_name.size-1)
        if params_name[k] == param_axisy_name then
          dir = dir.sub( fixed_param_strings[k], param_axisy_string )
        end
      end
    end
    if param_axisx_name != "VARIABLES" then
      # パラメータ軸, "VARIABLES", に対応する図のディレクトリは存在しない
      for k in 0..(params_name.size-1)
        if params_name[k] == param_axisx_name then
          dir = dir.sub( fixed_param_strings[k], param_axisx_string )
        end
      end
    end

    fig_paths[j][i] = dir
  end
end
for j in 0..(NParamAxisY-1)
  for i in 0..(NParamAxisX-1)
    file_fig_local = file_fig
    if param_axisy_name == "VARIABLES" then
      # パラメータ軸に "VARIABLES" が選択された時, ファイル名を変更
      file_fig_local = vars[j]
    end
    if param_axisx_name == "VARIABLES" then
      # パラメータ軸に "VARIABLES" が選択された時, ファイル名を変更
      file_fig_local = vars[i]
    end
    fig_paths[j][i] += "/" + file_fig_local
  end
end
#########################


put_header

#print "This is a test page for cgi.", "\n"


#print "Figure path:", "<br>", "\n"
#for j in 0..(fig_paths[0].size-1)
#  for i in 0..(fig_paths.size-1)
#    print "  [", i, "][", j, "] ", fig_paths[j][i], "\n"
#    print "<br>", "\n"
#  end
#end


if File.exist?( file_cgitop ) then
  f = File.open( file_cgitop, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

print "<table border=1>", "\n"

# param values
#print "  <td rowspan=", NParamAxisY, ">", "\n"
#print "    ", param_axisy_name, "\n"
#print "  </td>", "\n"

#   1st line
print "<tr>", "\n"
print "  <td colspan=2 rowspan=2>", "\n"
print "  </td>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
print '  <td colspan=', NParamAxisX, ' align=center>', "\n"
if param_axisx_unit == "" then
  print "    ", param_axisx_long_name, "<br>", "\n"
else
  print "    ", param_axisx_long_name, "<br>", "(", param_axisx_unit, ")", "\n"
end
print "  </td>", "\n"
print "</tr>", "\n"
#   2nd line
print "<tr>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
for i in 0..(NParamAxisX-1)
  print "  <td align=center>", "\n"
  if param_axisx_name == "VARIABLES" then
#    print "    ", yml_input["file_figs"].keys[i], "\n"
    print "    ", yml_input["file_figs"][yml_input["file_figs"].keys[i]], "\n"
  else
    print "    ", param_axisx_vals[i], "\n"
  end
  print "  </td>", "\n"
end
print "</tr>", "\n"

#   3rd, 4th, ... lines
for j in 0..(NParamAxisY-1)

  print "<tr>", "\n"

  if j == 0 then
    print "  <td rowspan=", NParamAxisY, " align=center>", "\n"
    if param_axisy_unit == "" then
      print "    ", param_axisy_long_name, "<br>", "\n"
    else
      print "    ", param_axisy_long_name, "<br>", "(", param_axisy_unit, ")", "\n"
    end
    print "  </td>", "\n"
  end

  print "  <td align=center>", "\n"
  if param_axisy_name == "VARIABLES" then
#    print "    ", yml_input["file_figs"].keys[j], "\n"
    print "    ", yml_input["file_figs"][yml_input["file_figs"].keys[j]], "\n"
  else
    print "    ", param_axisy_vals[j], "\n"
  end
  print "  </td>", "\n"

  for i in 0..(NParamAxisX-1)

    fig_path = fig_paths[j][i]

    print '  <td align="center">', "\n"
    if File.exist?(fig_path) then
      if File.extname(fig_path) == ".mp4" then
        print '    <video controls src="', fig_path, '" width=', fig_width, '></video>', "\n"
      else
        print '    <img src="', fig_path, '" width=', fig_width, 'alt="" title="">', "\n"
      end
      if flag_dirlink then
        print "<br>"
        print "\n"
        print '    <a href="', fig_path[0..fig_path.rindex("/")-1], '">[directory]</a>', "\n"
        print "\n"
      end
    else
      print '    No figure', "\n"
    end
    # debug
    if flag_debug then
      print '    ', fig_path, "\n"
    end
    #
    print '  </td>', "\n"
  end
  print "</tr>", "\n"

end

print "</table>", "\n"


if flag_show_info then

  print "<br>", "\n"
  print "<br>", "\n"

  #print "=======================", "\n"
  #print "<br>", "\n"
  print "<hr>", "\n"

  print "Figure file : ", file_fig, "\n"
  print "<br>", "\n"

  print "<br>", "\n"

  for i in 0..(params_name.size-1)
    print "Parameter ", i, " : ", params_name[i], "=", fixed_params_val[i], "\n"
    print "<br>", "\n"
  end

  print "<br>", "\n"

  print "Column : ", param_axisx_name, "\n"
  print "<br>", "\n"
  print "Row    : ", param_axisy_name, "\n"
  print "<br>", "\n"

  print "<br>", "\n"

  print "Figure width : ", fig_width, "\n"
  print "<br>", "\n"

  #print "=======================", "\n"
  #print "<br>", "\n"
  print "<hr>", "\n"

end

if File.exist?( file_cgibot ) then
  f = File.open( file_cgibot, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

put_footer

